/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    app_threadx.c
  * @author  MCD Application Team
  * @brief   ThreadX applicative file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "app_threadx.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define THREAD_STACK_SIZE 1024
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
uint8_t LED_thread_stack[THREAD_STACK_SIZE];
TX_THREAD led_thread_ptr;
uint8_t thread_stack2[THREAD_STACK_SIZE];
TX_THREAD thread_ptr2;
#define TRACEX_BUFFER_SIZE 64000
uint8_t tracex_buffer[64000];
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */
VOID my_thread_entry(ULONG intial_input);
VOID my_thread_entry2(ULONG intial_input);
/* USER CODE END PFP */

/**
  * @brief  Application ThreadX Initialization.
  * @param memory_ptr: memory pointer
  * @retval int
  */
UINT App_ThreadX_Init(VOID *memory_ptr)
{
  UINT ret = TX_SUCCESS;
  TX_BYTE_POOL *byte_pool = (TX_BYTE_POOL*)memory_ptr;

  /* USER CODE BEGIN App_ThreadX_Init */
  (void)byte_pool;
  tx_trace_enable(&tracex_buffer,TRACEX_BUFFER_SIZE,30);
  tx_thread_create(&led_thread_ptr, "led_thread", my_thread_entry, 0x1234, LED_thread_stack, THREAD_STACK_SIZE, 15,15,1,TX_AUTO_START);
  tx_thread_create(&thread_ptr2, "second_thread", my_thread_entry2, 0x2468, thread_stack2, THREAD_STACK_SIZE, 14,14,1,TX_AUTO_START);
  /* USER CODE END App_ThreadX_Init */

  return ret;
}

/**
  * @brief  MX_ThreadX_Init
  * @param  None
  * @retval None
  */
void MX_ThreadX_Init(void)
{
  /* USER CODE BEGIN  Before_Kernel_Start */

  /* USER CODE END  Before_Kernel_Start */

  tx_kernel_enter();

  /* USER CODE BEGIN  Kernel_Start_Error */

  /* USER CODE END  Kernel_Start_Error */
}

/* USER CODE BEGIN 1 */
VOID my_thread_entry(ULONG initial_input){
	printf("Thread Entry Reached\n");
	printf("\n");


	printf("Starting Loop...\n");
	while(1){
		HAL_GPIO_TogglePin(LED2_GPIO_Port, LED2_Pin); /*Defined in main.h*/
		printf("hello\n");
		tx_thread_sleep(200);
	}
}

VOID my_thread_entry2(ULONG initial_input){
	printf("Thread2 Entry Reached\n");
	printf("\n");


	printf("Starting Loop...\n");
	while(1){
		printf("Thread2\n");
		tx_thread_sleep(150);
	}
}

/* USER CODE END 1 */
